<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

$gartentechnik_com_rss_import_no_rss_cache = false;
add_filter('wp_feed_cache_transient_lifetime' , function($seconds) use(&$gartentechnik_com_rss_import_no_rss_cache) {
	if($gartentechnik_com_rss_import_no_rss_cache) {
		return 45 * 60;
	}
	return $seconds;
});
add_action('gartentechnik_com_rss_import', function() use(&$gartentechnik_com_rss_import_no_rss_cache) {
	gartentechnik_com_debug("RSS-Import-Start");
	require_once(__DIR__ . '/classes/RSSImporter.php');
	
	$domain = $_SERVER['HTTP_HOST'];
	if(preg_match('/^https?:\/\/([^\/]+)/', home_url('/'), $wp_url_hits)) {
		$domain = $wp_url_hits[1];
	}
	$gartentechnik_com_rss_import_no_rss_cache = true;
	$importer = new \GartentechnikCom\RSSImporter();
	$importer->import($domain);
	$gartentechnik_com_rss_import_no_rss_cache = false;
	gartentechnik_com_debug("RSS-Import-End");
});
function gartentechnik_com_rss_activation() {
	if(!wp_next_scheduled('gartentechnik_com_rss_import')) {
		gartentechnik_com_debug("RSS-Activate");
		wp_schedule_event(time(), 'hourly', 'gartentechnik_com_rss_import');
	}
}
register_activation_hook(__FILE__, 'gartentechnik_com_rss_activation');
?>
