<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

add_filter('the_posts', function($posts) use ($response) {
	gartentechnik_com_debug('the_posts_start');
	if(
		!\GartentechnikCom\Register::zeige_gtcom()
		||
		\GartentechnikCom\Register::ignoriere_the_posts_hook()
		||
		\GartentechnikCom\Register::ist_such_autovervollstaendigung()
	) {
		return ($posts);
	}
	
	global $wp_query;
	$wp_query->is_page = TRUE;
	$wp_query->is_singular = TRUE;
	$wp_query->is_home = FALSE;
	$wp_query->is_archive = FALSE;
	$wp_query->is_category = FALSE;
	$wp_query->is_search = FALSE;
	unset($wp_query->query['error']);
	$wp_query->query_vars['error'] = '';
	$wp_query->is_404 = FALSE;

	$post = \GartentechnikCom\Register::virtueller_post();
	if(!is_null($post)) {
		return array($post);
	}

	$post = new stdClass;
	$post->post_content = $response->main_content();
	$post->post_title = $response->html_head_titel();
	$post->post_name = $_SERVER['REQUEST_URI'] . '#';

	$post->ID = -11234555;
	$post->post_author = 1;
	$post->post_date = current_time('mysql');
	$post->post_date_gmt = current_time('mysql', 1);
	$post->post_excerpt = '';
	$post->post_status = 'publish';
	$post->comment_status = 'closed';
	$post->ping_status = 'closed';
	$post->post_password = '';
	$post->to_ping = '';
	$post->pinged = '';
	$post->modified = $post->post_date;
	$post->modified_gmt = $post->post_date_gmt;
	$post->post_content_filtered = '';
	$post->post_parent = 0;
	$post->guid = get_home_url('/' . $post->post_name);
	$post->menu_order = 0;
	$post->post_type = 'page';
	$post->post_mime_type = '';
	$post->comment_count = 0;

	if ($post->ID == -11234555) {
		$replace_function = function() {
			ob_start(function($buffer, $post) {
				$buffer = preg_replace('/<meta p.* \/>/', '', $buffer);
				return $buffer;
			});
		};
		add_action('template_redirect', $replace_function, -1);
		add_action('get_header', $replace_function);
		add_action('wp_footer', function() {
			ob_end_flush();
		}, 999);
	}

	add_filter( 'wpseo_opengraph_type', function($type) {
		return 'product';
	}, 20, 1 );

	add_filter( 'wpseo_metadesc', function($type) use ($response) {
		return $response->html_head_metadescription();
	}, 20, 1 );

	\GartentechnikCom\Register::virtueller_post($post);
	#header("X-GTCOM-DEBUG-POST: 1");
	gartentechnik_com_debug('the_posts_end');
	return (array($post));
}, 20, 1);

add_filter( 'the_title', function($title, $id = 0) use ($response) {
	gartentechnik_com_debug('the_title');
	if ($id == -11234555) {
		return $response->html_content_titel();
	}
	return $title;
}, 20, 2);

add_action('send_headers', function() use ($response) {
	gartentechnik_com_debug('send_header_start');
	if($response->redirect_location()) {
		#header("X-GTCOM-DEBUG-HEADER: 301");
		header("HTTP/1.1 301 MovedPermanently");
		header('Location: ' . $response->redirect_location());
	} elseif($response->is_404()) {
		#header("X-GTCOM-DEBUG-HEADER: 404");
		header("HTTP/1.1 404 NotFound");
	} else {
		#header("X-GTCOM-DEBUG-HEADER: 200");
	}
	gartentechnik_com_debug('send_header_end');
}, 20, 0);

add_filter('user_trailingslashit', function($url, $type) {
	gartentechnik_com_debug('trailingslash');
	if(\GartentechnikCom\Register::zeige_gtcom()) {
		if(preg_match('/#$/', $url)) {
			return $url;
		}
		return trailingslashit($url);
	}
	return $url;
}, 20, 2);
?>
