<?php
namespace GartentechnikCom;

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

add_filter('gartentechnik_com_template_frame', function($presenter_key, $template_key, $content) {
	return $content;
}, 0, 3);
add_filter('gartentechnik_com_template_block', function($presenter_key, $block_key, $content) {
	return $content;
}, 0, 3);

class Response {
	private $html_head_content = '';
	private $html_head_allgemein_content = '';
	private $html_head_titel = '';
	private $html_head_metadescription = '';
	private $html_content_titel = '';
	private $main_content = '';
	private $content_is_plain = false;
    private $html_footer_content = '';
	private $is_404 = true;
	private $redirect_location = '';
	private $content_type = 'text/html';
	private $charset = 'utf-8';
	private $widget_oeffnungszeiten = '';
	private $widget_kontaktformular = '';
	private $widget_newsletter_abonnieren = '';
	private $widget_haendleradresse = '';
	private $widget_angebote = '';
	private $widget_servicegebiet = '';
	private $kategoriebaum = null;
	private $allgemeine_html_header = '';
	private $admin_menue = null;
	private $einstellungen = null;
	private $widget_angesagte_kategorien = '';
	private $template_key = '';
	private $template_hook_content = [];
	public $temporary_presenter_key = '';

	# VOID
	function __construct() {
	}
	private function _uebersetze_variablen($content) {
		if(!$content) return $content;
		
		global $gartentechnik_com_pluginpfad;
		$content = preg_replace("/\[GT_RESOURCE_PATH\]/", plugins_url('resources/', $gartentechnik_com_pluginpfad), $content);
		$content = preg_replace("/\[WP_MAX_UPLOAD_FILESIZE_READABLE\]/", wp_convert_bytes_to_hr(wp_max_upload_size()), $content);
		$content = preg_replace("/\[WP_MAX_UPLOAD_FILESIZE\]/", wp_max_upload_size(), $content);
		return $content;
	}
	# BOOLEAN
	public function is_404($content = null) {
		if(!is_null($content)) $this->is_404 = ($content ? true : false);

		return $this->is_404;
	}
	# STRING
	public function redirect_location($content = null) {
		if(!is_null($content)) $this->redirect_location = $content;

		return $this->redirect_location;
	}
	# STRING
	public function template_key($key = null) {
		if(!is_null($key)) $this->template_key = $key;

		return $this->template_key;
	}
	# STRING
	public function content_type($content = null) {
		if(!is_null($content)) $this->content_type = $content;

		return $this->content_type;
	}
	# STRING
	public function charset($content = null) {
		if(!is_null($content)) $this->charset = $content;

		return $this->charset;
	}

	# STRING
	public function html_head_titel($content = null) {
		if(!is_null($content)) $this->html_head_titel = $content;

		return $this->html_head_titel;
	}
	# STRING
	public function html_head_metadescription($content = null) {
		if(!is_null($content)) $this->html_head_metadescription = $content;

		return $this->html_head_metadescription;
	}
	# STRING
	public function html_content_titel($content = null) {
		if(!is_null($content)) $this->html_content_titel = $content;

		return $this->html_content_titel;
	}
	# STRING
	public function main_content($content = null, $presenter_key = null) {
		if(!is_null($content)) {
			$content = $this->_behandle_content_hooks($content, $presenter_key);
			$this->main_content = $content;
		}
		
		return $this->_uebersetze_variablen($this->main_content);
	}
	# STRING
	private function _behandle_content_hooks($content, $presenter_key) {
		if(!$presenter_key || !$this->template_key()) {
			return $content;
		}
		
		$key = $this->template_key();
		$this->temporary_presenter_key = $presenter_key;
		$content = preg_replace_callback("/\{$key(.+?):(.*?)\}/", 'self::_decode_template_hook_content', $content);
		
		$content = preg_replace_callback("/\{$key:(.+?)\}/", 'self::_fill_template_hook_content', $content);
		
		return apply_filters(
			'gartentechnik_com_template_frame',
			$presenter_key,
			$this->template_key(),
			$content
		);
	}
	# STRING
	public static function _decode_template_hook_content($hit) {
		$content = base64_decode($hit[2]);
		
		$thisObject = \GartentechnikCom\MotoristPlugin::$response;
		$template_key = $thisObject->template_key();
		$block_key = $hit[1];
		$thisObject->template_hook_content($block_key, apply_filters(
			'gartentechnik_com_template_block',
			$thisObject->temporary_presenter_key,
			$block_key,
			$content
		));
		return '{' . $template_key . ':' . $block_key . '}';
	}
	# STRING
	public static function _fill_template_hook_content($hit) {
		$block_key = $hit[1];
		return \GartentechnikCom\MotoristPlugin::$response->template_hook_content($block_key);
	}
	# STRING
	public function template_hook_content($block_key, $content = null) {
		if(!is_null($content)) {
			$this->template_hook_content[$block_key] = $content;
		}
		return $this->template_hook_content[$block_key];
	}
	# STRING
	public function html_head_content($content = null) {
		if(!is_null($content)) $this->html_head_content = $content;

		return $this->_uebersetze_variablen($this->html_head_content);
	}
	# STRING
	public function html_head_allgemein_content($content = null) {
		if(!is_null($content)) $this->html_head_allgemein_content = $content;

		return $this->_uebersetze_variablen($this->html_head_allgemein_content);
	}
    # STRING
    public function html_footer_content($content = null) {
        if(!is_null($content)) $this->html_footer_content = $content;

        return $this->_uebersetze_variablen($this->html_footer_content);
    }
	# STRING
	public function widget_oeffnungszeiten($content = null) {
		if(!is_null($content)) $this->widget_oeffnungszeiten = $content;

		return $this->_uebersetze_variablen($this->widget_oeffnungszeiten);
	}
	# STRING
	public function widget_kontaktformular($content = null) {
		if(!is_null($content)) $this->widget_kontaktformular = $content;

		return $this->_uebersetze_variablen($this->widget_kontaktformular);
	}
	# STRING
	public function widget_newsletter_abonnieren($content = null) {
		if(!is_null($content)) $this->widget_newsletter_abonnieren = $content;

		return $this->_uebersetze_variablen($this->widget_newsletter_abonnieren);
	}
	# STRING
	public function widget_haendleradresse($content = null) {
		if(!is_null($content)) $this->widget_haendleradresse = $content;

		return $this->_uebersetze_variablen($this->widget_haendleradresse);
	}
	# STRING
	public function widget_angebote($content = null) {
		if(!is_null($content)) $this->widget_angebote = $content;

		return $this->_uebersetze_variablen($this->widget_angebote);
	}
	# STRING
	public function widget_angesagte_kategorien($content = null) {
		if(!is_null($content)) $this->widget_angesagte_kategorien = $content;

		return $this->_uebersetze_variablen($this->widget_angesagte_kategorien);
	}
	# STRING
	public function widget_lieferanten($content = null) {
		if(!is_null($content)) $this->widget_lieferanten = $content;

		return $this->_uebersetze_variablen($this->widget_lieferanten);
	}
	# STRING
	public function widget_servicegebiet($content = null) {
		if(!is_null($content)) $this->widget_servicegebiet = $content;

		return $this->_uebersetze_variablen($this->widget_servicegebiet);
	}
	# STRING
	public function allgemeine_html_header($content = null) {
		if(!is_null($content)) $this->allgemeine_html_header = $content;

		return $this->_uebersetze_variablen($this->allgemeine_html_header);
	}
	# ARRAY
	public function kategoriebaum($content = null) {
		if(!is_null($content)) $this->kategoriebaum = $content;

		if(!$this->kategoriebaum) $this->kategoriebaum = [];

		return $this->kategoriebaum;
	}
	# ARRAY
	public function admin_menue($content = null) {
		if(!is_null($content)) $this->admin_menue = $content;

		if(!$this->admin_menue) $this->admin_menue = [];

		return $this->admin_menue;
	}
	# ARRAY
	public function einstellungen($content = null) {
		if(!is_null($content)) $this->einstellungen = $content;

		return $this->einstellungen;
	}
	# BOOLEAN
	public function content_is_plain($content = null) {
		if(!is_null($content)) $this->content_is_plain = $content;

		return $this->content_is_plain;
	}
}
?>
