<?php
namespace GartentechnikCom\Widget;

if (!defined('ABSPATH')) exit; // Exit if accessed directly

require_once(__DIR__ . '/../Widget.php');

class Angebote extends \GartentechnikCom\Widget {
	function __construct() {
		parent::__construct('gartentechnik-com-angebote', 'Angebote', 'Platzhalter, der durch die Händler-Angebote ersetzt wird');
	}
	
	# STRING
	protected function _get_content($args, $instance) {
		$title = apply_filters('widget_title', @$instance['title']);
		if (!empty($title)) {
			$title = @$args['before_title'] . $title . @$args['after_title'];
		}
		
		$inhalt = $this->response->widget_angebote();
		
		libxml_use_internal_errors(true);
		
		$inhalt = preg_replace('/€/', '&euro;', $inhalt);
		$inhalt = utf8_decode($inhalt);
		$doc = new \DOMDocument("1.0", "ISO-8859-15");
		$doc->loadHTML($inhalt, LIBXML_HTML_NOIMPLIED | LIBXML_HTML_NODEFDTD);
		
		$xpath = new \DOMXpath($doc);
		$liste = $xpath->query("//li");

		$vorhandene_angebote = 0;
		foreach ($liste as $e) {
			if ($e->getAttribute('data-element-typ') == 'angebot') {
				$vorhandene_angebote++;
			}
		}

		$benoetigte_auffueller = $instance['angebote_auffuellen'] - $vorhandene_angebote;
		$vorhandene_produkte = 0;
		foreach ($liste as $e) {
			if ($e->getAttribute('data-element-typ') != 'angebot' ) {
				$benoetigte_auffueller--;
				if ($benoetigte_auffueller < 0) {
					$parent = $e->parentNode;
					$parent->removeChild($e);
					continue;
				}
			}
			$vorhandene_produkte++;
		}
		$inhalt = $doc->saveHTML();
		
		
		if (!$vorhandene_produkte) {
			return '<!-- Angebote sind nicht vorhanden -->';
		}
		
		return $title . $inhalt . "<span class='gartentechnik_com_zeilen_angebote' data-zeilen='" . $instance['zeilen_angebote'] . "'></span>" . "<style>" . $instance['benutzerdefiniertes_css'] . "</style>";
	}
	
	# VOID
	public function form($instance) {
		if (isset($instance['title'])) {
			$title = $instance['title'];
		} else {
			$title = '';
		}
		
		if (isset($instance['benutzerdefiniertes_css'])) {
			$benutzerdefiniertes_css = $instance['benutzerdefiniertes_css'];
		} else {
			$benutzerdefiniertes_css = null;
		}
		
		if (isset($instance['zeilen_angebote'])) {
			$zeilen_angebote = $instance['zeilen_angebote'];
		} else {
			$zeilen_angebote = null;
		}
		
		if (isset($instance['angebote_auffuellen'])) {
			$angebote_auffuellen = $instance['angebote_auffuellen'];
		} else {
			$angebote_auffuellen = null;
		}
		require(__DIR__ . '/../../templates/angebotewidget_editor.tpl.php');
	}
	
	# OBJ
	public function update($new_instance, $old_instance) {
		$instance = array();
		$instance['title'] = (!empty($new_instance['title'])) ? strip_tags($new_instance['title']) : '';
		$instance['angebote_auffuellen'] = (!empty($new_instance['angebote_auffuellen'])) ? strip_tags($new_instance['angebote_auffuellen']) * 1 : '0';
		$instance['zeilen_angebote'] = (!empty($new_instance['zeilen_angebote'])) ? strip_tags($new_instance['zeilen_angebote']) * 1 : '1';
		$instance['benutzerdefiniertes_css'] = (!empty($new_instance['benutzerdefiniertes_css'])) ? strip_tags($new_instance['benutzerdefiniertes_css']) : '';
		return $instance;
	}
}

?>
