<?php
namespace GartentechnikCom\Widget;

if (!defined('ABSPATH')) exit; // Exit if accessed directly

require_once(__DIR__ . '/../Widget.php');

class AngesagteKategorien extends \GartentechnikCom\Widget {
	function __construct() {
		parent::__construct('gartentechnik-com-angesagte-kategorien', 'Angesagte Kategorien', 'Platzhalter, der durch die derzeit angesagten Gartentechnik-Kategorien ersetzt wird');
	}
	
	# STRING
	protected function _get_content($args, $instance) {
		$title = apply_filters('widget_title', @$instance['title']);
		if (!empty($title)) {
			$title = @$args['before_title'] . $title . @$args['after_title'];
		}
		
		$daten = $this->response->widget_angesagte_kategorien();
		$liste = json_decode($daten, true);
		if (!is_array($liste)) {
			return '';
		}
		
		array_splice($liste, @$instance['anzahl']);
		
		$sort_helper = array();
		foreach ($liste as $key => $row) {
			$sort_helper[$key] = $row['name'];
		}
		array_multisort($sort_helper, SORT_ASC, SORT_STRING, $liste);
		
		$inhalt = '';
		foreach ($liste as $kategorie) {
			$inhalt .= "<a href=\"" . $kategorie['link'] . "\">" . $kategorie['name'] . "</a>, ";
		}
		$inhalt = substr($inhalt, 0, -2);
		return $title . "$inhalt";
	}
	
	# VOID
	public function form($instance) {
		if (isset($instance['title'])) {
			$title = $instance['title'];
		} else {
			$title = '';
		}
		
		if (isset($instance['anzahl'])) {
			$anzahl = $instance['anzahl'];
		} else {
			$anzahl = null;
		}
		
		require(__DIR__ . '/../../templates/angesagtekategorienwidget_editor.tpl.php');
	}
	
	# OBJ
	public function update($new_instance, $old_instance) {
		$instance = array();
		$instance['title'] = (!empty($new_instance['title'])) ? strip_tags($new_instance['title']) : '';
		$instance['anzahl'] = (!empty($new_instance['anzahl'])) ? strip_tags($new_instance['anzahl']) * 1 : '10';
		return $instance;
	}
}

?>
