<?php
namespace GartentechnikCom\Widget;

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

require_once(__DIR__ . '/../Widget.php');

class Produkt extends \GartentechnikCom\Widget {
	function __construct() {
		parent::__construct('gartentechnik-com-produkt', 'Produkt', 'Platzhalter, der durch ein konkretes Produkt ersetzt wird');
	}
	# STRING
	protected function _get_content($args, $instance) {
		$title = apply_filters('widget_title', @$instance['title']);
		if(!empty($title)) {
			echo @$args['before_title'] . $title . @$args['after_title'];
		}
		
		echo '<div id="gartentechnik_com_produktwidget_inhalt_' . $args['id'] . '"></div>'
			. '<script type="text/javascript">'
				. 'if(!window.gartentechnik_com_produktwidget) {'
					. 'window.gartentechnik_com_produktwidget = [];'
				. '}'
				. 'window.gartentechnik_com_produktwidget.push({'
					. '"id": "' . $instance['produkt_id'] . '",'
					. '"widget_id": "' . $args['id'] . '"'
				. '});'
			. '</script>'
		;
	}
	# VOID
	public function form($instance) {
		if (isset($instance['title'])) {
			$title = $instance['title'];
		} else {
			$title = '';
		}
		if (isset($instance['produkt_id'])) {
			$produkt_id = $instance['produkt_id'];
		} else {
			$produkt_id = null;
		}
		if (isset($instance['produkt_title'])) {
			$produkt_title = $instance['produkt_title'];
		} else {
			$produkt_title = null;
		}
		require(__DIR__ . '/../../templates/produktwidget_editor.tpl.php');
	}
	# OBJ
	public function update( $new_instance, $old_instance ) {
		$instance = array();
		$instance['title'] = ( ! empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';
		$instance['produkt_id'] = ( ! empty( $new_instance['produkt_id'] ) ) ? strip_tags( $new_instance['produkt_id'] ) : '';
		$instance['produkt_title'] = ( ! empty( $new_instance['produkt_title'] ) ) ? strip_tags( $new_instance['produkt_title'] ) : '';
		return $instance;
	}
}
?>
