<?php
    if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
	# HASH
	function gartentechnik_com_ermittle_blog_dateigroessen() {
		$wp_upload_path_config = wp_upload_dir();
		$wp_upload_basedir = $wp_upload_path_config['basedir'];
		$real_wp_upload_basedir = preg_replace('/[ \n\r\t]/', '', shell_exec("readlink -f $wp_upload_basedir"));
		$disk_usage = shell_exec("du -s $real_wp_upload_basedir/sites/*");
		$blog_groessen = [];
		foreach(explode("\n", $disk_usage) as $l) {
			if(preg_match('/(\d+).*?(\d+)[ \n\t]*$/', $l, $hit)) {
				$blog_groessen[$hit[2]] = $hit[1];
			}
		}
		return $blog_groessen;
	}
	# ARRAY
	function gartentechnik_com_ermittle_obsolete_blogtabellen() {
		global $wpdb;
		$results = $wpdb->get_results('SHOW TABLES LIKE "wp\_%\_%"');
		$blog_ids = [];
		foreach($results as $o) {
			foreach(get_object_vars($o) as $tablename) {
				if(preg_match('/^wp_(\d+)_/', $tablename, $hits)) {
					$blog_ids['' . $hits[1]] = true;
				}
			}
		}
		$list = [];
		foreach($blog_ids as $blog_id => $true) {
			$tabellen_results = $wpdb->get_results("SHOW TABLES LIKE 'wp\_${blog_id}\_%'");
			$ok = false;
			$tabellen_liste = [];
			foreach($tabellen_results as $to) {
				foreach(get_object_vars($to) as $tabelle) {
					if($tabelle == "wp_${blog_id}_posts") {
						$ok = true;
						break;
					}
					array_push($tabellen_liste, $tabelle);
				}
			}
			if(!$ok) {
				$list = array_merge($list, $tabellen_liste);
			}
		}
		return $list;
	}
	# ARRAY
	function gartentechnik_com_ermittle_alle_blogdaten() {
		global $wpdb;
		$results = $wpdb->get_results('SHOW TABLES LIKE "wp_%_options"');
		$list = [];
		$blog_dateigroessen = gartentechnik_com_ermittle_blog_dateigroessen();
		foreach($results as $o) {
			foreach(get_object_vars($o) as $tablename) {
				if(preg_match('/^wp_(\d+)_options$/', $tablename, $hits)) {
					$blog_id = $hits[1];
					$options = $wpdb->get_results("
						SELECT
							b.domain AS domain,
							IF(o.option_value IS NULL, 'Default(TwentyFifteen)', o.option_value) AS theme,
							IF(b.archived = 1 OR b.spam = 1 OR b.deleted = 1, 'aus', 'aktiv') AS status,
							IF(okey.option_value IS NULL, '-x', okey.option_value) AS gtcom_option
						FROM wp_blogs AS b
						LEFT JOIN $tablename AS o
							ON o.option_name = 'current_theme'
						LEFT JOIN $tablename AS okey
							ON okey.option_name = 'gartentechnik_com_einstellungen'
						WHERE
							b.blog_id = $blog_id
					");
					if(!count($options)) continue;
	
					$gtcom_optionen = unserialize($options[0]->gtcom_option);
					$api_key = ($gtcom_optionen ? $gtcom_optionen['gartentechnik_com_api_key'] : '');
					$list[] = [
						'theme'		=> $options[0]->theme,
						'domain'	=> $options[0]->domain,
						'status'	=> $options[0]->status,
						'dateigroesse'	=> ($blog_dateigroessen[$blog_id] ? $blog_dateigroessen[$blog_id] : 0),
						'api_key'	=> ($api_key ? $api_key : '-'),
					];
				}
			}
		}
		$domains = array();
		foreach ($list as $key => $row) {
			$domains[$key] = $row['domain'];
		}
		array_multisort($domains, SORT_ASC, SORT_STRING, $list);
		return $list;
	}
	$gartentechnik_com_blogliste = gartentechnik_com_ermittle_alle_blogdaten();
	$gartentechnik_com_obsolete_tabellen = gartentechnik_com_ermittle_obsolete_blogtabellen();
	
	$gartentechnik_com_stammdaten_liste = $app->sende_admin_api_anfrage(
		[
			'api_method'	=> 'GET',
			'api_path'		=> 'stammdaten',
			
		], [],
		$ist_admin_kontext, $ist_superadmin_kontext, $rolle_des_aktuellen_users
	);
	$gartentechnik_com_api_key_liste = [];
	foreach($gartentechnik_com_stammdaten_liste as $e) {
		$gartentechnik_com_api_key_liste[$e['website']['wordpress_api_key']] = [
			'ist_ein_testshop'	=> $e['ist_ein_testshop'],
			'ist_aktiv'			=> $e['ist_aktiv'],
		];
	}
?>
<div class="wrap gartentechnik_com-admin">
	<h2>Übersicht der Einstellungen der Motoristen-Blogs</h2>
	<p>
		<strong>HINWEIS:</strong>
		Die Liste enthält nur die Daten der zentralen Multisite-Wordpress-Instanzen.
	</p>
	<style>
		.gartentechnik_com-admin table {
			border-collapse: collapse;
		}
		.gartentechnik_com-admin table td,
		.gartentechnik_com-admin table th {
			border: solid 1px #CCC;
			padding: 0.3em 0.5em;
		}
		.gartentechnik_com-admin tr.aus,
		.gartentechnik_com-admin tr.aus a {
			color: #CCC;
		}
		.gartentechnik_com-admin tr.rot td {
			background-color: #FF9999;
		}
		.gartentechnik_com-admin tr.grau td,
		.gartentechnik_com-admin tr.grau a {
			background-color: #999;
		}
	</style>
	<table>
		<thead>
			<tr>
				<th>Motorist</th>
				<th>Theme</th>
				<th>Blog-Status</th>
				<th>Dateigröße</th>
				<th>GT-API-Key</th>
				<th>GT-Status</th>
			</tr>
		</thead>
		<tfoot/>
		<tbody>
			<?php foreach($gartentechnik_com_blogliste as $e) { ?>
				<?php
					$gt_daten = $gartentechnik_com_api_key_liste[$e['api_key']];
					$gt_status = (!$gt_daten ? 'keinGT' :
						(!$gt_daten['ist_aktiv'] ? 'InAktiv' :
							($gt_daten['ist_ein_testshop'] ? 'testshop' : 'ok')
						)
					);
					
					if($gt_status == 'ok' || $e['status'] == 'aus') {
						$status_farbe = 'gruen';
					} else if($gt_status == 'keinGT' || $gt_status == 'InAktiv') {
						$status_farbe = 'rot';
					} else if($gt_status == 'testshop') {
						$status_farbe = 'grau';
					}
				?>
				<tr
					class="<?php echo $e['status'] . ' ' . $status_farbe ?>"
				>
					<td><a href="https://<?php echo $e['domain']; ?>" target="_blank"><?php echo $e['domain']; ?></a></td>
					<td><?php echo $e['theme']; ?></td>
					<td><?php echo $e['status']; ?></td>
					<td><?php echo sprintf("%.1f", $e['dateigroesse'] / 1024) . " MB"; ?></td>
					<td><?php echo $e['api_key']; ?></td>
					<td><?php echo $gt_status; ?></td>
				</tr>
			<?php } ?>
		</tbody>
	</table>
	
	<h3>Obsolete DB-Tabellen</h3>
	<ul>
		<?php foreach($gartentechnik_com_obsolete_tabellen as $tabelle) { ?>
			<li><?php echo $tabelle; ?></li>
		<?php } ?>
	</ul>
</div>
